UpdateHandler = class(Turbine.UI.Control)
function UpdateHandler:Constructor(UpdateDelay)
    Turbine.UI.Control.Constructor(self)
    self:SetWantsUpdates(true)

    self.oldGameTime = Turbine.Engine.GetGameTime()

    self.UpdateDelay = UpdateDelay or 0

    self.UpdateEvent = function(sender, event, args)
        if type(event)=="function" then
            event(args)
        else
            if type(event)=="table" then
                for i=1,#event do
                    if type(event[i])=="function" then
                        event[i](args)
                    end
                end
            end
        end
    end

    if self.UpdateDelay > 0 then 
        self.Update = function()
            local currentGameTime = Turbine.Engine.GetGameTime()
            if currentGameTime == self.oldGameTime or currentGameTime - self.oldGameTime < self.UpdateDelay then
                return true
            end
        
            self.UpdateEvent(self, self.ExecuteUpdate, currentGameTime - self.oldGameTime)
            self.oldGameTime = currentGameTime
        end
        
    else
        self.Update = function()
            local currentGameTime = Turbine.Engine.GetGameTime()
            if currentGameTime ~= self.oldGameTime then
                local delta = currentGameTime - self.oldGameTime
                self.UpdateEvent(self, self.ExecuteUpdate, delta)
                self.oldGameTime = currentGameTime
            end
        end
        
    end
end
 
function UpdateHandler:GetUpdateCount()
    return tablelength(self.ExecuteUpdate)
end